package chatui;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import chat.ChatServer;
import chat.ChatListener;

public class ChatUI extends JFrame {
    protected final ChatServer server;
    protected final JList channelList;
    protected final JButton sendMessage;
    protected final JButton newListener;
    protected final JButton flood;
    protected final JTextField message;    
    protected final JPanel buttons;
    protected long listeners=0;

    public ChatUI(int bufferSize, String[] channels) {
	super("Chat system test UI");
	getContentPane().setLayout(new BorderLayout());
	buttons=new JPanel();
	setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
	server=new ChatServer(bufferSize, channels);	
	channelList=new JList(channels);
	getContentPane().add(channelList, BorderLayout.CENTER);
	message=new JTextField();
	message.setColumns(80);
	getContentPane().add(message, BorderLayout.NORTH);
	sendMessage=new JButton("Send message");
	sendMessage.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    final String c=(String)channelList.getSelectedValue();
		    if (c!=null)
			new Thread() {
			    public void run() {
				server.writeMessage(c, message.getText());
			    }
			}.start();
		}
	    });
	buttons.add(sendMessage);
	newListener=new JButton("New listener");
	newListener.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    String c=(String)channelList.getSelectedValue();
		    if (c!=null)
			new ListenWindow(server, c,
					 "Listener "+c+"-"+listeners++).
			    setVisible(true);
		}
	    });
	buttons.add(newListener);
	flood=new JButton("Message flood");
	flood.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    final String c=(String)channelList.getSelectedValue();
		    if (c!=null)
			new Thread() {
			    public void run() {
				for(int i=0;i<100;i++)
				    server.writeMessage(c, "Flood message "+i);
			    }
			}.start();		    
		}
	    });
	buttons.add(flood);
	getContentPane().add(buttons, BorderLayout.SOUTH);
	setSize(480,360);
    }

    public static void main(String[] args) {
	if (args.length<1) {
	    System.err.println("Syntax: java chatui.ChatUI <buffersize> "+
			       "<channel names>");
	    System.exit(1);
	}

	String[] chan=new String[args.length-1];

	for(int i=1; i<args.length; i++)
	    chan[i-1]=args[i];
	new ChatUI(Integer.parseInt(args[0]), chan).setVisible(true);
    }
}
